import modal

from ..ffmpeg_app import ffmpeg_worker_image, app, config, s3_mount, local_copy_to_s3, output_path_prefix

with ffmpeg_worker_image.imports():
    from BowongModalFunctions.models.cache_tasks.models import MediaSource
    from BowongModalFunctions.models.enums.models import MediaProtocol
    from BowongModalFunctions.utils.PathUtils import FileUtils
    from BowongModalFunctions.utils.SentryUtils import SentryUtils
    from BowongModalFunctions.utils.VideoUtils import VideoUtils
    from BowongModalFunctions.models.ffmpeg_tasks.models import FFMPEGSliceOptions, SentryTransactionInfo, WebhookNotify, \
    FFMPEGResult
    import sentry_sdk
    from typing import Optional, Tuple
    from modal import current_function_call_id


    @app.function(timeout=3600 * 3, cloud="aws",
                  max_containers=config.ffmpeg_worker_concurrency,
                  cpu=(0.5, 64),
                  volumes={
                      s3_mount: modal.CloudBucketMount(
                          bucket_name=config.S3_bucket_name,
                          secret=modal.Secret.from_name("aws-s3-secret",
                                                        environment_name=config.modal_environment),
                      ),
                  }, )
    @modal.concurrent(max_inputs=1)
    async def ffmpeg_convert_stream(media: MediaSource,
                                    options: FFMPEGSliceOptions,
                                    sentry_trace: Optional[SentryTransactionInfo] = None,
                                    webhook: Optional[WebhookNotify] = None) -> Tuple[
        FFMPEGResult, Optional[SentryTransactionInfo]]:
        fn_id = current_function_call_id()

        @SentryUtils.sentry_tracker(name="处理直播流转换为MP4视频任务", op="ffmpeg.convert.stream", fn_id=fn_id,
                                    sentry_trace_id=sentry_trace.x_trace_id if sentry_trace else None,
                                    sentry_baggage=sentry_trace.x_baggage if sentry_trace else None)
        @SentryUtils.webhook_handler(webhook=webhook, func_id=fn_id)
        async def ffmpeg_process(media_stream: MediaSource, func_id: str, options: FFMPEGSliceOptions) -> FFMPEGResult:
            match media_stream.protocol:
                case MediaProtocol.hls:
                    stream_url = media_stream.path
                case MediaProtocol.s3:
                    stream_url = media_stream.cache_filepath
                case _:
                    raise NotImplementedError(f"暂不支持使用{media_stream.protocol.value}协议")
            output_path = f"{output_path_prefix}/{config.modal_environment}/convert_stream/{func_id}/output.mp4"

            local_output, metadata = await VideoUtils.ffmpeg_convert_stream_media(
                media_stream_url=stream_url,
                options=options,
                output_path=output_path)
            s3_outputs = local_copy_to_s3([local_output])

            return FFMPEGResult(urn=s3_outputs[0], metadata=metadata,
                                content_length=FileUtils.get_file_size(local_output), )

        result = await ffmpeg_process(media_stream=media, func_id=fn_id, options=options)

        if not sentry_trace:
            sentry_trace = SentryTransactionInfo(x_trace_id=sentry_sdk.get_traceparent(),
                                                 x_baggage=sentry_sdk.get_baggage())

        return result, sentry_trace
